
// 0000-9999 reversive BCD counter
module counter_dec4(
	clock,
	dir,
	ena,
	rst,
	outhex );

	input clock;
	input dir;
	input ena;
	input rst;

	output [15:0] outhex;
	wire   [15:0] outhex;

decimal d0( .clock(clock), .dir(dir), .ena(ena), .rst(rst), .out(outhex[3:0]), .ovf(ovf0) );
decimal d1( .clock(clock), .dir(dir), .ena(ena&ovf0), .rst(rst), .out(outhex[7:4]), .ovf(ovf1) );
decimal d2( .clock(clock), .dir(dir), .ena(ena&ovf0&ovf1), .rst(rst), .out(outhex[11:8]), .ovf(ovf2) );
decimal d3( .clock(clock), .dir(dir), .ena(ena&ovf0&ovf1&ovf2), .rst(rst), .out(outhex[15:12]) );

endmodule


// 4bit BCD reversive counter
module decimal(
	clock,
	dir,
	ena,
	rst,
	out,
	ovf );

	input clock;
	input dir;
	input ena;
	input rst;

	output [3:0] out;
	reg    [3:0] out;

	output ovf;
	reg    ovf;


	always @(posedge clock)
	if( rst==1'b1 ) // reset
	begin
		out = 3'd0;
	end
	else if( ena==1'b1 )
	begin
		if( dir==1'b0 ) // decrement
			out = out - 4'd1;
		else // increment
			out = out + 4'd1;

		if( out==4'd10 ) out=4'd0; else if( out==4'd15 ) out=4'd9;
	end

	always @*
	begin
		if( (dir==1'b0)&&(out==4'd0) ) ovf<=1'b1;
		else if( (dir==1'b1)&&(out==4'd9) ) ovf<=1'b1;
		else ovf<=1'b0;
	end

endmodule










